package dev.ninjdai.werewolf.commands.lg;

import dev.ninjdai.werewolf.gui.Gui;
import dev.ninjdai.werewolf.gui.GuiItem;
import dev.ninjdai.werewolf.gui.GuiItems;
import dev.ninjdai.werewolf.gui.StackedGui;
import dev.ninjdai.werewolf.uhc.UHCConfig;
import dev.ninjdai.werewolf.uhc.roles.Role;
import dev.ninjdai.werewolf.uhc.roles.Roles;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.text.format.Style;
import net.kyori.adventure.text.format.TextDecoration;
import net.minestom.server.MinecraftServer;
import net.minestom.server.command.builder.Command;
import net.minestom.server.component.DataComponentMap;
import net.minestom.server.entity.Player;
import net.minestom.server.inventory.InventoryType;
import net.minestom.server.item.ItemStack;
import net.minestom.server.item.Material;
import net.minestom.server.timer.TaskSchedule;
import org.jetbrains.annotations.NotNull;

public class LGConfiguration extends Command {
    public static final UHCConfig config = new UHCConfig();
    private static final Gui lgConfig = new StackedGui(InventoryType.CHEST_6_ROW, Component.text("LG Configuration", NamedTextColor.DARK_RED));
    private static final Gui lgRoleConfig = new StackedGui(
            InventoryType.CHEST_6_ROW,
            Component.text("LG Configuration - Roles", NamedTextColor.DARK_RED),
            lgConfig
    );

    static {
        lgConfig.addGuiItem(4, 2, new GuiItem(
            ItemStack.of(Material.PAINTING).withCustomName(Component.text("Roles", NamedTextColor.YELLOW).decoration(TextDecoration.ITALIC, false)),
            event -> {
                event.setCancelled(true);
                event.getPlayer().openInventory(lgRoleConfig);
            }
        ));

        int roleSlot = 0;
        for (Roles role: Roles.values()) {
            final int finalRoleSlot = roleSlot;
            lgRoleConfig.addGuiItem(roleSlot, new GuiItem(
                ItemStack.of(Material.RED_TERRACOTTA).withCustomName(role.get().getName()).withLore(role.get().getDescription()),
                (event, guiItem) -> config.activatedRoles.compute(role.get(), (_r, integer) -> {
                    if (integer==null) integer = 0;

                    switch (event.getClickType()) {
                        case LEFT_CLICK ->  {
                            if (role.get().isDuo()) integer = 2;
                            else integer = Math.min(integer+1, role.get().getRoleMaxCount());
                        }
                        case RIGHT_CLICK -> {
                            if (role.get().isDuo()) integer = 0;
                            else integer = Math.max(integer-1, 0);
                        }
                    }

                    if (integer > 0) guiItem.setItemStack(guiItem.getItemStack().withMaterial(Material.GREEN_TERRACOTTA).withAmount(integer));
                    else guiItem.setItemStack(guiItem.getItemStack().withMaterial(Material.RED_TERRACOTTA).withAmount(1));
                    lgRoleConfig.updateItemStack(finalRoleSlot);

                    event.getPlayer().sendMessage(Component.text(String.format("There will be %d ", integer)).append(role.get().getName()).append(Component.text(" in the game")));

                    return integer;
                })
            ));
            roleSlot++;
        }

    }
    
    public LGConfiguration() {
        super("configure");

        setDefaultExecutor((sender, context) -> {
            if (!(sender instanceof Player player)){
                sender.sendMessage("You're not a player !");
                return;
            }

            player.openInventory(lgConfig);
        });
    }
}
