package dev.ninjdai.werewolf.uhc.roles;

import dev.ninjdai.werewolf.uhc.effects.neutrals.AssassinStrength;
import dev.ninjdai.werewolf.uhc.effects.werewolves.WerewolfStrength;
import net.kyori.adventure.text.Component;
import net.minestom.server.component.DataComponent;
import net.minestom.server.item.ItemComponent;
import net.minestom.server.item.ItemStack;
import net.minestom.server.item.Material;
import net.minestom.server.item.component.EnchantmentList;
import net.minestom.server.item.component.PotionContents;
import net.minestom.server.item.enchant.Enchantment;
import net.minestom.server.potion.PotionType;

public enum Roles {
    // Werewolves
    WEREWOLF(new Role.Builder().setId("werewolf").setName(Component.text("Werewolf")).setRoleMaxCount(99).addRoleEffect(new WerewolfStrength()).build()),
    // Villagers
    ANCIENT(new Role.Builder().setId("ancient").setName(Component.text("Ancient")).build()),
    VILLAGER(new Role.Builder().setId("villager").setName(Component.text("Villager")).setRoleMaxCount(99).build()),
    SISTER(new Role.Builder().setId("sister").setName(Component.text("Sister")).setRoleDuo().build()),
    WITCH(new Role.Builder().setId("witch").setName(Component.text("Witch")).addRoleItems(
            ItemStack.of(Material.SPLASH_POTION, 2).with(ItemComponent.POTION_CONTENTS, new PotionContents(PotionType.STRONG_HEALING))
    ).build()),
    // Neutrals
    ASSASSIN(new Role.Builder().setId("assassin").setName(Component.text("Assassin")).addRoleEffect(new AssassinStrength()).build()),
    CUPID(new Role.Builder().setId("cupid").setName(Component.text("Cupid")).addRoleItems(
            ItemStack.of(Material.ENCHANTED_BOOK).with(ItemComponent.ENCHANTMENTS, EnchantmentList.EMPTY.with(Enchantment.PUNCH, 1)),
            ItemStack.of(Material.ARROW, 64)
    ).build()),
    ;

    private final Role role;
    Roles(Role role) {
        this.role = role;
    }

    public Role get() {
        return this.role;
    }
}
